'===============================================================================
' String.bas
' Stringverarbeitungsfunktionen
' Erstellt am 07.12.2013
' Letzte Bearbeitung am 26.10.14 - geschwindigkeitsoptimiert von fxm:
' http://www.freebasic.net/forum/viewtopic.php?f=7&t=22997
'===============================================================================


Function CountString(s1 As String, s2 As String) As Integer
	'Gibt zurueck, wie oft der String s2 im String s1 vorkommt
	
	Dim As Integer i, count
 
	count = 0
	i = 1
	Do
		i = Instr(i, s1, s2)
		If i > 0 Then
			count += 1
			i += Len(s2)
		End If
	Loop Until i = 0
 
	Return count  
	
End Function


Function SubString(s1 As String, s2 As String, k As Integer) As String
	'Liefert den k-ten Substring in einem String s1 mit der Trennzeichenfolge s2.
	'k beginnt ab 1

	Dim As Integer i, j, count
	Dim As String s
 
	count = 0
	i = 1
	s = s1
	Do
		j = i
		i = Instr(i, s1, s2)
		If i > 0 Then
		  count += 1
		  i += Len(s2)
		End If
	Loop Until i = 0 Or count = k

	If i > 0 Or count = k - 1 Then
		If i = 0 Then
			s = Mid(s1, j)
		Else
			s = Mid(s1, j, i - Len(s2) - j)
		End If
	End If
 
	Return s

End Function
		
		 
Function ReplaceString(s1 As String, s2 As String, s3 As String) As String
	'Ersetzt alle Teilstrings s2 in s1 durch den String s3 und gibt den
	'geänderten String zurueck
	
	Dim As Integer i
	Dim As String s
 
	s = s1
	i = 1
	Do
		i = Instr(i, s, s2)
		If i > 0 Then s = Left(s, i - 1) & s3 & Mid(s, i + Len(s2)): i += Len(s3)
	Loop Until i = 0
 
	Return s
	
End Function


Function InsertString(s1 As String, s2 As String, k As Integer) As String
	'Fuegt im String s1 an der Stelle k den String s2 ein
	
	Return Left(s1, k - 1) & s2 & Mid(s1, k)
		
End Function


Function LeftSet(s As String, Laenge As Integer) As String
  'Gibt den String s linksbündig mit der angegebenen Laenge aus
  
	Dim As String s0
 
	s0 = Space(Laenge)
	Lset s0, s
 
	Return s0
  
End Function


Function RightSet(s As String, Laenge As Integer) As String
  'Gibt den String s rechtsbuendig mit der angegebenen Laenge aus
  
  Dim As String s0
 
	s0 = Space(Laenge)
	Rset s0, s
 
	Return s0
  
End Function
  
